import '../../fireflutter.dart';

///
class PartyService with FirestoreMixin, DatabaseMixin {
  static PartyService? _instance;
  static PartyService get instance {
    _instance ??= PartyService();
    return _instance!;
  }

  attend({partyId: String, repeatId: String, planner: String}) {
    return FunctionsApi.instance.request('attendParty',
        data: {'partyId': partyId, 'repeatId': repeatId, 'planner': planner},
        addAuth: true);
  }

  unattend({partyId: String, repeatId: String, planner: String}) {
    FunctionsApi.instance.request('attendParty',
        data: {'partyId': partyId, 'repeatId': repeatId, 'planner': planner},
        addAuth: true);
  }

  sendEventPushMessage({partyId: String, title: String, content: String}) {
    return FunctionsApi.instance.request('sendMessageToEvent',
        data: {"partyId": partyId, "title": title, "content": content},
        addAuth: true);
  }
}
